datablock AudioProfile(c4TrigSound)
{
	filename    = "./sound/c4_click.wav";
	description = AudioClose3d;
	preload = true;
};
datablock ProjectileData(c4Projectile : gunProjectile)
{
	projectileShapeName 	= "base/data/shapes/empty.dts";
	directDamage        	= 50;
	explodeOnDeath = 1;
	explosion 				= grenadeLauncherExplosion;
	directDamageType    	= $DamageType::C4;
	radiusDamageType    	= $DamageType::C4;
};
datablock ItemData(c4Item)
{
	category = "Weapon";
	className = "Weapon";
	
	weaponClass = "slot3";

	shapeFile = "./model/c4_ammo.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	uiName = "C4";
	iconName = "./model/icon/icon_c4";
	fakeIcon = c4Icon;
	doColorShift = true;
	colorShiftColor = "1 0.7 0.6 1";
	ammo = 1;
	canPutInSuitcase = 0;
	isLargeWeapon = 0;

	image = c4Image;
	canDrop = true;
	
	sAmmoType = "c4";
	sAmmoMode = "thrown";
	sAmmo = 1;
	sAmmoPickupGenericNoise = 1;
	noAmmolessSpawn = 1;
	
	spawnMaxAmmoAlways = 1;
	noSpawnWithAmmoNear = 1;
};
datablock ItemData(c4DroppedItem)
{
	category = "Weapon";
	className = "Weapon";
	
	weaponClass = "primary";

	shapeFile = "./model/c4.dts";
	rotate = false;
	mass = 100;
	density = 0.9;
	elasticity = 0.05;
	friction = 2;
	sticky = 1;
	emap = true;

	uiName = "";
	iconName = "";
	doColorShift = true;
	colorShiftColor = c4Item.colorShiftColor;

	canDrop = false;
	isAmmo = 1;
	sAmmo = 1;
	sAmmoType = "c4";
	sAmmoPickupGenericNoise = 1;
};
datablock ShapeBaseImageData(c4Image)
{
	className = "WeaponImage";
	shapeFile = "./model/c4.dts";
	emap = true;
	mountPoint = 0;
	offset = "0 0.1 0.04";
	eyeOffset = "0.6 1.2 -0.45";
	rotation = "0 1 0 90";
	eyeRotation = "0 1 0 20";
	item = c4Item;
	ammo = " ";
	
	armReady = true;
	
	
	doColorShift = true;
	colorShiftColor = c4Item.colorShiftColor;
};
datablock ShapeBaseImageData(c4TriggerImage)
{
	className = "WeaponImage";
	shapeFile = "./model/c4_trigger.dts";
	emap = true;
	mountPoint = 1;
	offset = "0 0 0";
	eyeOffset = "-0.7 1 -0.45";
	eyeRotation = "0 0.4 1 30";
	item = c4Item;
	ammo = " ";
	
	projectile = gunProjectile;
	projectileType = Projectile;
	
	
	armReady = true;
	correctMuzzleVector = true;
	
	
	doColorShift = true;
	colorShiftColor = "0.7 0.7 0.3 1";
	
	stateName[0] 					= "Activate";
	stateTransitionOnTimeout[0] 	= "Idle";
	stateTimeoutValue[0] 			= 0.2;
	stateSequence[0] 				= "up";

	stateName[1] 					= "Idle";
	stateTransitionOnTriggerDown[1] = "Trig";

	stateName[2] 					= "Trig";
	stateSequence[2] 				= "trig";
	stateTransitionOnTimeout[2] 	= "Wait";
	stateSound[2]					= c4TrigSound;
	stateWaitForTimeout[2] 			= true;
	stateTimeoutValue[2] 			= 0.2;
	stateAllowImageChange[2]		= false;
	stateFire[2]					= true;
	stateScript[2] 					= "onTrig";

	stateName[3]					= "Wait";
	stateTimeoutValue[3] 			= 0.4;
	stateTransitionOnTimeout[3] 	= "Down";
	
	stateName[4] 					= "Down";
	stateTimeoutValue[4] 			= 0.2;
	stateSequence[4] 				= "down";
	stateTransitionOnTimeout[4] 	= "Done";
	
	stateName[5]					= "Done";
	stateScript[5]					= "onDone";
};
function c4TriggerImage::onTrig(%db,%pl,%slot)
{
	%pl.schedule(100,detonateC4);
}
function c4TriggerImage::onDone(%db,%pl,%slot)
{
	%pl.unMountImage(%slot);
	if(isObject(%pl.getMountedImage(0)))
		%pl.playThread(1,armReadyRight);
	else
		%pl.playThread(1,root);
	if(sAmmo_rCheck(%db,%pl,0) <= 0)
	{
		%cnt = %pl.getDatablock().maxTools;
		for(%i=0;%i<%cnt;%i++)
		{
			%slot = %pl.tool[%i];
			if(%slot == nameToId(%db.item))
			{
				messageClient(%pl.client,'MsgItemPickup','',%i,0,1);
				%pl.tool[%i] = 0;
			}
		}
	}
	%pl.disableCmdSwap = 0;
	%pl.delayedCmdSwap();
}

function player::cleanupC4(%pl)
{
	if(isObject(%pl.droppedC4Set))
	{
		%i = %pl.droppedC4Set.getCount();
		while(%i-->=0)
		{
			%o = %pl.droppedC4Set.getObject(%i);
			if(%o.isGoingToExplode)
				continue;
			if(isFunction(item,fadeOutKill))
				%o.fadeOutKill(0,6);
			else
				%o.delete();
		}
	}
}
function player::detonateC4(%pl)
{
	%cnt = %pl.droppedC4Set.getCount();
	for(%i=0;%i<%cnt;%i++)
	{
		%o = %pl.droppedC4Set.getObject(%i);
		schedule(50*%i,%o,detonateC4Obj,%pl,%o);
		%o.isGoingToExplode = 1;
	}
}
function detonateC4Obj(%pl,%obj)
{
	if(!isObject(%obj))
		return;
	%p = new projectile()
	{
		initialPosition = %obj.getPosition();
		datablock = c4Projectile;
		client = %pl.client;
		sourceObject = %pl;
	};
	%p.explode();
	%obj.delete();
}