

datablock AudioProfile(crossbowFireSound)
{
	filename    = "./sound/crossbow_fire.wav";
	description = AudioDefault3d;
	preload = true;
};
datablock AudioProfile(crossbowLoadSound : crossbowFireSound)
{
	filename    = "./sound/crossbow_load.wav";
	description = AudioClose3d;
};
datablock AudioProfile(crossbowCockSound : crossbowFireSound)
{
	filename    = "./sound/crossbow_cock.wav";
	description = AudioDefault3d;
};
datablock AudioProfile(crossbowImpactEnv1Sound : crossbowFireSound)
{
	filename    = "./sound/bolt_hit_env1.wav";
	description = AudioClosest3d;
};
datablock AudioProfile(crossbowImpactEnv2Sound : crossbowImpactEnv1Sound)
{
	filename    = "./sound/bolt_hit_env2.wav";
	description = AudioClosest3d;
};
datablock AudioProfile(crossbowImpactPl1Sound : crossbowImpactEnv1Sound)
{
	filename    = "./sound/bolt_hit_pl1.wav";
	description = AudioClose3d;
};
datablock AudioProfile(crossbowImpactPl2Sound : crossbowImpactEnv1Sound)
{
	filename    = "./sound/bolt_hit_pl2.wav";
	description = AudioClose3d;
};

datablock ParticleData(crossbowTrailParticle)
{
	dragCoefficient      = 1;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0;
	constantAcceleration = 0.0;
	lifetimeMS           = 1100;
	lifetimeVarianceMS   = 400;
	textureName          = "base/data/particles/dot";
	spinSpeed			= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]			= "0.6 0.6 0.6 0.25";
	colors[1]			= "0.55 0.55 0.55 0.22";
	colors[2]			= "0.53 0.53 0.53 0";
	sizes[0]			= 0.01;
	sizes[1]			= 0.08;
	sizes[2]			= 0.06;
	times[0]			= 0;
	times[1]			= 0.2;
	times[2]			= 1;
	useInvAlpha 		= true;
};

datablock ParticleEmitterData(crossbowTrailEmitter)
{
	ejectionPeriodMS	= 1;
	periodVarianceMS	= 0;
	ejectionVelocity	= 0;
	velocityVariance	= 0;
	ejectionOffset  	= 0.0;
	thetaMin			= 0;
	thetaMax			= 90;
	phiReferenceVel		= 0;
	phiVariance			= 360;
	overrideAdvance		= false;
	particles			= crossbowTrailParticle;
};
datablock ProjectileData(crossbowProjectile : gunProjectile)
{
	projectileShapeName 	= "./model/bolt.dts";
	directDamage        	= 95;
	headshotDamage			= 142;
	doNotBlowHeadOff = 1;
	explodeOnDeath = 1;
	explosion 				= "";
	directDamageType    	= $DamageType::Crossbow;
	headshotDamageType		= $DamageType::CrossbowHeadshot;
	radiusDamageType    	= $DamageType::Crossbow;
	particleEmitter     	= crossbowTrailEmitter;
	uiName 					= "";
	muzzleVelocity 			= 200;
	verticalImpulse 		= 5;
	impactImpulse			= 5;
	lifeTime				= 20000;
	sound 					= "";
	sProjectile 			= 1;
	gravityMod 				= 0.2;
	isBallistic 			= 1;
	noBulletWhiz = 1;
	armingDelay = 125;
	minStickVelocity = 0;
	bounceAngle = 200;
	collideWithPlayers = 1;
	explodeOnPlayerImpact = 1;
	explodeOnDeath = 1;
	
	impactImpulse = 200;
	verticalImpulse = 100;
	
	sDamageFalloff = 3;
	sDamageFalloffRatio = 0.04;
	
	sSpecialPlImpactCnt = 2;
	sSpecialPlImpactPrefix = "crossbowImpactPl";
	
	sSpecialEnvImpactCnt = 2;
	sSpecialEnvImpactPrefix = "crossbowImpactEnv";
};
datablock ItemData(crossbowItem)
{
	category = "Weapon";
	className = "Weapon";
	
	weaponClass = "primary";

	shapeFile = "./model/crossbow.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	uiName = "Crossbow";
	iconName = "./model/icon/icon_crossbow";
	doColorShift = true;
	colorShiftColor = "0.57 0.35 0.2 1";
	ammo = 1;
	isLargeWeapon = 1;
	
	image = crossbowImage;
	canDrop = true;
	
	sAmmoType = "bolts";
	sAmmo = 1;
};
datablock ShapeBaseImageData(crossbowImage)
{
	className = "WeaponImage";
	shapeFile = "./model/crossbow.dts";
	emap = true;
	mountPoint = 0;
	offset = "-0.014 0 -0.08";
	item = crossbowItem;
	ammo = " ";
	projectile = crossbowProjectile;
	projectileSpread = 0;
	projectileSpeed = 200;
	projectileType = Projectile;
	
	casing = "";
	shellExitDir        = "0.2 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 12.0;	
	shellVelocity       = 7.0;
	
	armReady = true;
	
	eyeOffset = 0;
	
	doColorShift = true;
	colorShiftColor = crossbowItem.colorShiftColor;
	
	
	stateName[0]					= "Ready";
	stateSequence[0]				= "root";
	stateTimeoutValue[0]			= 0.3;
	stateTransitionOnTimeout[0] 	= "ReleaseA";

	stateName[1]					= "ReleaseA";
	stateSequence[1]				= "root";
	stateTimeoutValue[1]			= 0.01;
	stateTransitionOnTriggerUp[1]	= "Idle";

	stateName[2]					= "Idle";
	stateTransitionOnNotLoaded[2]	= "FireCheckA";
	stateTransitionOnTriggerDown[2]	= "FireCheckA";

	stateName[3]					= "FireCheckA";
	stateScript[3]					= "onFireCheck";
	stateTimeoutValue[3]			= 0.01;
	stateTransitionOnTimeout[3]		= "FireCheckB";

	stateName[4]					= "FireCheckB";
	stateTransitionOnAmmo[4]		= "Cock";
	stateTransitionOnNoAmmo[4]		= "DryFire";

	stateName[5]					= "Cock";
	stateSequence[5]				= "cock";
	stateTimeoutValue[5]			= 0.3;
	stateScript[5] 					= "onCock";
	stateTransitionOnTimeout[5]		= "LoadA";

	stateName[6]					= "LoadA";
	stateTimeoutValue[6]			= 0.5;
	stateTransitionOnTimeout[6]		= "LoadB";

	stateName[7]					= "LoadB";
	stateTimeoutValue[7]			= 0.01;
	stateSequence[7]				= "load";
	stateScript[7]					= "onLoad";
	stateTransitionOnTimeout[7]		= "LoadC";

	stateName[8]					= "ReleaseB";
	stateTransitionOnTriggerUp[8]	= "Primed";

	stateName[9]					= "Primed";
	stateTransitionOnTriggerDown[9]	= "Trigger";

	stateName[10]					= "Trigger";
	stateSequence[10]				= "trig";
	stateSound[10]					= flareGunDryFireSound;
	stateScript[10]					= "onTrigger";
	stateTimeoutValue[10]			= 0.02;
	stateTransitionOnTimeout[10]	= "Fire";

	stateName[11]					= "Fire";
	stateSequence[11]				= "fire";
	stateScript[11]					= "onFire";
	stateTransitionOnTimeout[11]	= "Untrig";
	stateTimeoutValue[11]			= 0.07;

	stateName[12]					= "Untrig";
	stateTimeoutValue[12]			= 0.01;
	stateSequence[12]				= "untrig";
	stateTransitionOnTimeout[12]	= "Delay";

	stateName[13]					= "Delay";
	stateTimeoutValue[13]			= 0.2;
	stateTransitionOnTimeout[13]	= "ReleaseA";

	stateName[14]					= "DryFire";
	stateSequence[14]				= "drytrig";
	stateTimeoutValue[14]			= 0.04;
	stateScript[14]					= "onDryFire";
	stateSound[14]					= flareGunDryFireSound;
	stateTransitionOnTimeout[14]	= "DryDelay";

	stateName[15]					= "LoadC";
	stateTimeoutValue[15]			= 0.4;
	stateTransitionOnTimeout[15]	= "ReleaseB";

	stateName[16]					= "DryDelay";
	stateTimeoutValue[16]			= 0.1;
	stateTransitionOnTimeout[16]	= "Untrig";

};
function crossbowImage::onMount(%db,%pl,%slot)
{
	if(%pl.sAmmo[%tmp = nameToId(%db.item)] > 0)
	{
		%pl.sAmmo[%tmp] = 0;
	}
	parent::onMount(%db,%pl,%slot);
}
function crossbowImage::onUnMount(%db,%pl,%slot)
{
	if(%pl.sAmmo[%tmp = nameToId(%db.item)] > 0)
	{
		%pl.sAmmo[%tmp] = 0;
		%pl.sReserve[%tmp.sAmmoType]++;
	}
	parent::onUnMount(%db,%pl,%slot);
}
function crossbowImage::onDryFire(%db,%pl,%slot)
{
	%pl.playThread(2,plant);
	sWeps_displayNotif(%pl,"warn");
}
function crossbowImage::onCock(%db,%pl,%slot)
{
	%pl.playThread(2,plant);
	serverPlay3D(crossbowCockSound,%pl.getPosition());
}
function crossbowImage::onLoad(%db,%pl,%slot)
{
	%pl.playThread(2,shiftLeft);
	serverPlay3D(crossbowLoadSound,%pl.getPosition());
	sAmmo_rDec(%db,%pl,%slot);
	sAmmo_load(%db,%pl,%slot,1);
}
function crossbowImage::onFire(%db,%pl,%slot)
{
	if(%pl.getDamagePercent() >= 1)
		return;
	%pl.playThread(2,plant);
	sWeps_fire(%db,%pl,%slot);
	serverPlay3D(crossbowFireSound,%pl.getPosition());
	%val = sAmmo_dec(%db,%pl,%slot);
	if(%pl.sReserve[nameToId(%db.item)] <= 0)
		%pl.setImageAmmo(%slot,0);
	%pl.setImageLoaded(%slot,1);
}
function crossbowImage::onFireCheck(%db,%pl,%slot)
{
	%pl.setImageAmmo(%slot,sAmmo_rCheck(%db,%pl,%slot));
}
function crossbowBoltItemFix(%brick)
{
	cancel(%brick.crossbowBoltFixSched);
	%brick.crossbowBoltFixSched = "";
	if(isObject(%item = %brick.item))
	{
		if(%item.getDatablock().uiName $= "Ammo Bolts")
		{
			%brick.setItemPosition(%brick.itemPosition);
		}
	}
}
package swol_crossbow
{
	function itemData::onAdd(%db,%item)  //stupid model shit
	{
		if(%db.uiName $= "Crossbow")
			%item.playThread(1,root);
		parent::onAdd(%db,%item);
	}
	function fxDtsBrick::setItem(%brick,%item)
	{
		if(%item.uiName $= "Ammo Bolts")
		{
			%brick.crossbowBoltFixSched = schedule(5,%brick,crossbowBoltItemFix,%brick);
		}
		parent::setItem(%brick,%item);
	}
	function fxDtsBrick::setItemPosition(%brick,%pos)
	{
		if(isObject(%item = %brick.item))
		{
			%db = %item.getDatablock();
			if(%db.uiName $= "Ammo Bolts")
			{
				cancel(%brick.crossbowBoltFixSched);
				%brick.crossbowBoltFixSched = "";
				if(%pos > 1)
				{
					%item.playThread(1,quiver);
					%item.hideNode("case");
					switch(%pos)
					{
						case 2:
							%dir = 5;
							%rot = "0 0 -1 " @ $piOver2;
						case 3:
							%dir = 2;
							%rot = "0 0 1 0";
						case 4:
							%dir = 3;
							%rot = "0 0 1 " @ $piOver2;
						case 5:
							%dir = 4;
							%rot = "0 0 -1 " @ $pi;
					}
					%item.setTransform(%item.getPosition() SPC %rot);
					%brick.itemDirection  = %dir;
				}
				else if(%pos == 1)
				{
					%doDownFix = 1;
				}
			}
		}
		parent::setItemPosition(%brick,%pos);
		if(%doDownFix)
		{
			%rot = getWords(%item.getTransform(),3,6);
			%pos = vectorAdd(%item.getPosition(),"0 0 1.68");
			%item.setTransform (%pos SPC %rot);
		}
	}
	function fxDtsBrick::setItemDirection(%brick,%pos)
	{
		if(isObject(%item = %brick.item))
		{
			%db = %item.getDatablock();
			if(%db.uiName $= "Ammo Bolts")
			{
				if(%brick.itemPosition > 1)
					return;
			}
		}
		parent::setItemDirection(%brick,%pos);
	}
};
activatePackage(swol_crossbow);