datablock AudioProfile(fragBounceSound)
{
	filename    = "./sound/frag_bounce.wav";
	description = AudioClose3d;
	preload = true;
};
datablock AudioProfile(fragPinSound)
{
	filename    = "./sound/frag_pin.wav";
	description = AudioClose3d;
	preload = true;
};
datablock DebrisData(fragHandleDebris)
{
	shapeFile = "./model/frag_handle.dts";
	lifetime = 2.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 4;
};
datablock ParticleData(fragTrailParticle)
{
	dragCoefficient			= 3.0;
	windCoefficient			= 0.0;
	gravityCoefficient		= 0.0;
	inheritedVelFactor		= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS				= 800;
	lifetimeVarianceMS		= 0;
	spinSpeed				= 10.0;
	spinRandomMin			= -50.0;
	spinRandomMax			= 50.0;
	useInvAlpha				= false;
	animateTexture			= false;

	textureName		= "base/data/particles/dot";

	colors[0]	= "0.1 0.1 0.1 0";
	colors[1]	= "0.1 0.1 0.1 0.15";
	colors[2]	= "0.1 0.1 0.1 0";
	sizes[0]	= 0.4;
	sizes[1]	= 0.2;
	sizes[2]	= 0.05;
	times[0]	= 0.0;
	times[1]	= 0.1;
	times[2]	= 1.0;
};

datablock ParticleEmitterData(fragTrailEmitter)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 0;

   ejectionVelocity = 0;
   velocityVariance = 0; 

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = fragTrailParticle;
};

datablock ParticleData(shrapFragParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 625;
	lifetimeVarianceMS   = 455;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.9 0.2 0.2 0.4";
	colors[1]     = "0.6 0.4 0.0 0.0";
	sizes[0]      = 0.15;
	sizes[1]      = 0.3;

	useInvAlpha = false;
};
datablock ParticleEmitterData(shrapFragEmitter)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 1;
   ejectionVelocity = 0.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = shrapFragParticle;
};
datablock ParticleData(fragExplosionSmokeParticle)
{
	dragCoefficient      = 5;
	gravityCoefficient   = -0.1;
	inheritedVelFactor   = 0;
	constantAcceleration = 0.0;
	lifetimeMS           = 2700;
	lifetimeVarianceMS   = 900;
	textureName          = "base/data/particles/cloud";
	spinSpeed			= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]			= "0.4 0.4 0.4 0.4";
	colors[1]			= "0.5 0.5 0.5 0.3";
	colors[2]			= "0.6 0.6 0.6 0";
	sizes[0]			= 2;
	sizes[1]			= 9;
	sizes[2]			= 8;
	times[0]			= 0;
	times[1]			= 0.1;
	times[2]			= 1;
	useInvAlpha 		= true;
};

datablock ParticleEmitterData(fragExplosionSmokeEmitter)
{
	ejectionPeriodMS	= 9;
	periodVarianceMS	= 0;
	ejectionVelocity	= 9;
	velocityVariance	= 4;
	ejectionOffset  	= 2;
	thetaMin			= 0;
	thetaMax			= 90;
	phiReferenceVel		= 0;
	phiVariance			= 360;
	overrideAdvance		= false;
	particles			= fragExplosionSmokeParticle;
};
datablock ParticleData(fragExplosionFlareParticle)
{
	dragCoefficient      = 1;
	gravityCoefficient   = -0.6;
	inheritedVelFactor   = 0;
	constantAcceleration = 0.0;
	lifetimeMS           = 1300;
	lifetimeVarianceMS   = 200;
	textureName          = "base/data/particles/cloud";
	spinSpeed			= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]			= "1 0.7 0 0.6";
	colors[1]			= "0.9 0.3 0 0.5";
	colors[2]			= "0.7 0.2 0 0";
	sizes[0]			= 1;
	sizes[1]			= 7;
	sizes[2]			= 5;
	times[0]			= 0;
	times[1]			= 0.1;
	times[2]			= 1;
	useInvAlpha 		= false;
};

datablock ParticleEmitterData(fragExplosionFlareEmitter)
{
	ejectionPeriodMS	= 4;
	periodVarianceMS	= 0;
	ejectionVelocity	= 0;
	velocityVariance	= 0;
	ejectionOffset  	= 3.0;
	thetaMin			= 0;
	thetaMax			= 90;
	phiReferenceVel		= 0;
	phiVariance			= 360;
	overrideAdvance		= false;
	particles			= fragExplosionFlareParticle;
};
datablock explosionData(fragExplosion)
{
	lifetimeMS 				= 150;
	
	particleEmitter 		= fragExplosionFlareEmitter;
	particleDensity 		= 12;
	particleRadius 			= 0.1;
	soundProfile 			= grenadeLauncherExplosionASound;

	
	emitter[0]				= "";
	emitter[1] 				= fragExplosionSmokeEmitter;
	emitter[2] 				= "";
	
	debris 					= grenadeLauncherExplosionDebris;
	debrisNum 				= 7;
	debrisNumVariance 		= 3;
	debrisPhiMin 			= 0;
	debrisPhiMax 			= 360;
	debrisThetaMin 			= 0;
	debrisThetaMax 			= 180;
	debrisVelocity 			= 35;
	debrisVelocityVariance 	= 15;

	radiusDamage = 30;
	damageRadius = 16;
	
	impulseForce = 1800;
	impulseRadius = 20;
	
	faceViewer = 1;
	
	explosionScale = "1 1 1";
	
	shakeCamera = true;
	camShakeRadius = 20;
	camShakeAmp = "1 2 1";
	camShakeDuration = 3;
	camShakeFallOff = 10;
	camShakeFreq = "2 4 2";
	cameraShakeFalloff = 1;
};
datablock ProjectileData(fragProjectile : gunProjectile)
{
	projectileShapeName 	= "./model/frag_proj.dts";
	directDamage        	= 2;
	explodeOnDeath = 1;
	directDamageType    	= $DamageType::FragGrenade;
	radiusDamageType    	= $DamageType::FragGrenade;
	particleEmitter     	= fragTrailEmitter;
	uiName 					= "";
	muzzleVelocity 			= 200;
	verticalImpulse 		= 20;
	impactImpulse			= 20;
	lifeTime				= 20000;
	sound 					= "";
	sProjectile 			= 0;
	noBulletWhiz = 1;
	gravityMod 				= 1;
	isBallistic 			= 1;
	armingDelay = 20000;
	
	explosion = "fragExplosion";
	
	sound = "";
	
	impactImpulse = 0;
	verticalImpulse = 0;
};
datablock ProjectileData(fragStaticProjectile : gunProjectile)
{
	projectileShapeName 	= "./model/frag_projStatic.dts";
	directDamage        	= 2;
	explodeOnDeath = 1;
	directDamageType    	= $DamageType::FragGrenade;
	radiusDamageType    	= $DamageType::FragGrenade;
	particleEmitter     	= "";
	uiName 					= "";
	muzzleVelocity 			= 200;
	verticalImpulse 		= 20;
	impactImpulse			= 20;
	lifeTime				= 20000;
	sound 					= "";
	sProjectile 			= 0;
	noBulletWhiz = 1;
	gravityMod 				= 1;
	isBallistic 			= 1;
	armingDelay = 20000;
	
	explosion = "fragExplosion";
	
	sound = "";
	
	impactImpulse = 0;
	verticalImpulse = 0;
};
datablock ProjectileData(fragmentProjectile : gunProjectile)
{
	projectileShapeName 	= "./model/frag_fragment.dts";
	directDamage        	= 20;
	explodeOnDeath = 1;
	directDamageType    	= $DamageType::FragGrenade;
	radiusDamageType    	= $DamageType::FragGrenade;
	particleEmitter     	= shrapFragEmitter;
	uiName 					= "";
	muzzleVelocity 			= 200;
	verticalImpulse 		= 20;
	impactImpulse			= 20;
	lifeTime				= 20000;
	sound 					= "";
	sProjectile 			= 1;
	gravityMod 				= 1;
	isBallistic 			= 1;
	armingDelay = 1000;
	collideWithPlayers = 1;
	explodeOnPlayerImpact  = 0;
	
	explosion = "";
	
	sound = "";
	
	impactImpulse = 0;
	verticalImpulse = 0;
};
datablock ItemData(fragItem)
{
	category = "Weapon";
	className = "Weapon";
	
	weaponClass = "slot3";

	shapeFile = "./model/frag.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	uiName = "Frag Grenade";
	iconName = "./model/icon/icon_frag";
	doColorShift = true;
	colorShiftColor = "0.24 0.39 0.17 1";
	ammo = 1;
	canPutInSuitcase = 0;
	isLargeWeapon = 0;

	image = fragImage;
	canDrop = true;
	
	sAmmoType = "grenade";
	sAmmoMode = "thrown";
	sAmmo = 1;
	sAmmoPickupGenericNoise = 1;
	noAmmolessSpawn = 1;
};

datablock ShapeBaseImageData(fragImage)
{
	className = "WeaponImage";
	shapeFile = "./model/frag.dts";
	emap = true;
	mountPoint = 0;
	offset = "-0.01 0.035 0";
	eyeOffset = "0 0 0";
	rotation = "0 0 1 20";
	eyeRotation = "0 0 0 0";
	item = fragItem;
	ammo = " ";
	
	casing = fragHandleDebris;
	shellExitDir        = "0.2 0.9 0.1";
	shellExitVariance   = 0.0;	
	shellVelocity       = 1.0;
	
	armReady = true;
	
	projectile = fragProjectile;
	projectileType = Projectile;
	
	
	doColorShift = true;
	colorShiftColor = fragItem.colorShiftColor;
	
	stateName[0]					= "Ready";
	stateTimeoutValue[0]			= 0.2;
	stateSequence[0]				= "root";
	stateTransitionOnTimeout[0]		= "ReleaseA";
	
	stateName[1]					= "ReleaseA";
	stateTransitionOnTriggerUp[1]	= "Idle";
	
	stateName[2]					= "Idle";
	stateTransitionOnTriggerDown[2]	= "pullPin";
	
	stateName[3]					= "pullPin";
	stateSequence[3]				= "pull";
	stateScript[3]					= "onPinPull";
	stateTimeoutValue[3]			= 0.1;
	stateTransitionOnTimeout[3]		= "pinDrop";
	
	stateName[4]					= "pinDrop";
	stateScript[4]					= "onPinDrop";
	stateSequence[4]				= "pinPop";
	stateTimeoutValue[4]			= 0.01;
	stateTransitionOnTimeout[4]		= "handlePop";
	
	stateName[5]					= "Wait";
	stateTimeoutValue[5]			= 0.3;
	stateTransitionOnTimeout[5]		= "ReleaseB";
	
	stateName[6]					= "ReleaseB";
	stateTransitionOnTriggerUp[6]	= "ReadyIdle";
	
	stateName[7]					= "ReadyIdle";
	stateTransitionOnTriggerDown[7]	= "Throw";
	
	stateName[8]					= "handlePop";
	stateEjectShell[8]				= true;
	stateSequence[8]				= "handlePop";
	stateTimeoutValue[8]			= 0.01;
	stateTransitionOnTimeout[8]		= "Wait";
	
	stateName[9]					= "Throw";
	stateScript[9]					= "onFire";
	stateFire[9]					= true;
};
function fragGrenade_explode(%proj,%expos)
{
	if(!isObject(%proj))
		return;
	%expos = %proj.getPosition();
	%plCnt = 0;
	initContainerRadiusSearch(%expos,20,$TypeMasks::PlayerObjectType);
	while(%pl = containerSearchNext())
	{
		//%dist = vectorDist(%pl.getPosition(),%pos);
		%plList[%plCnt] = %pl;
		%plCnt++;
	}
	%check = 0;
	
	%ex = getWord(%expos,0);
	%ey = getWord(%expos,1);
	%ez = getWord(%expos,2);
	for(%i=0;%i<64;%i++)
	{
		%rnd = getRandom();
		%force = (getRandom(600,1000)/1000)*100;
		%bias = getRandom(0,(%plCnt*2)-1);
		if(%plcnt > 0 && %bias < %plCnt)
		{
			%pl = %plList[%bias];
			%ppos = %pl.getHackPosition();
			%px = getWord(%ppos,0);
			%py = getWord(%ppos,1);
			%pz = getWord(%ppos,2);
			%dx = %px-%ex;
			%dy = %py-%ey;
			%dz = %pz-%ez;
			
			%mag = mSqrt((%dx*%dx)+(%dy*%dy)+(%dz*%dz));
	
			%vx = (%dx/%mag);
			%vy = (%dy/%mag);
			%vz = (%dz/%mag);
			
			%vec = %vx SPC %vy SPC %vz;
			
			%a = (getRandom()-0.5)*($PI*2);
			%spread = 0.25;
			%xMod = mCos(%a)*(getRandom()*%spread);
			%yMod = mSin(%a)*(getRandom()*%spread);
			
			%forward = vectorNormalize(%vx SPC %vy SPC 0);
			%trueUp = "0 0 1";
			%right = vectorCross(%forward,%trueUp);
			%up = vectorCross(%right,%vec);
			
			%vec = vectorAngleRotate(%vec,%up,%xMod);
			%vec = vectorAngleRotate(%vec,%right,%yMod);
			%vec = vectorScale(%vec,%force);
		}
		else
		{
			%z = (getRandom())*%force;
			%x = mCos(%rnd*$PI*2)*%force;
			%y = mSin(%rnd*$PI*2)*%force;
			%vec = %x SPC %y SPC %z;
		}
		%pos = vectorAdd(%expos,(%x*getRandom()*4) SPC (%y*getRandom()*4) SPC (%z*getRandom()*4));
		%pos = %expos;
		%p = new projectile()
		{
			datablock = fragmentProjectile;
			initialPosition = %pos;
			initialVelocity = %vec;
			client = %proj.client;
			sourceObject = %proj.client;
		};
		if(getRandom(0,1))
			%p.setNetFlag(6,1);
		%p.schedule(390,delete);
	}
	%p = new projectile()
	{
		datablock = fragProjectile;
		initialPosition = %expos;
		initialVelocity = "0 0 5";
		client = %proj.client;
		sourceObject = %proj.client;
	};
	%p.explode();
	%proj.delete();
}
function fragImage::onPinPull(%db,%pl,%slot)
{
	%pl.disableCmdSwap = 1;
	%pl.playThread(2,shiftRight);
	serverPlay3D(fragPinSound,%pl.getPosition());
	%pl.fragPinPullTime = getSimTime();
	%pl.fragExplodeInHand = %pl.schedule(4000,fragExplodeInhand);
}
function player::fragExplodeInhand(%pl)
{
	cancel(%pl.fragExplodeInHand);
	%pos = %pl.getSlotTransform(0);
	%p = sWeps_fire(fragImage,%pl,0,0,1,1);
	fragGrenade_explode(%p);
	%item = fragItem;
	sAmmo_rDec(%item.image,%pl,0);
	%pl.unMountImage(0);
	%pl.playThread(1,root);
}
function fragImage::onPinDrop(%db,%pl,%slot)
{

}
function fragImage::onFire(%db,%pl,%slot)
{
	serverPlay3D(molotovThrowSound,%pl.getPosition());
	%p = sWeps_fire(%db,%pl,0,0,30,1);
	%time = (4000-(getSimTime()-%pl.fragPinPullTime));
	%p.explodeIn = %time+getSimTime();
	schedule(%time,%p,fragGrenade_explode,%p);
	cancel(%pl.fragExplodeInHand);
	%pl.schedule(100,playThread,1,root);
	%pl.playThread(2,spearThrow);
	%pl.playThread(3,shiftTo);
	%pl.schedule(100,delayedCmdSwap);
	%pl.schedule(300,doImageRemount,fragImage);
	sAmmo_rDec(%db,%pl,%slot);
	%pl.unMountImage(%slot);
}
function fragImage::onUnMount(%db,%pl,%slot)
{
	%pl.disableCmdSwap = 0;
	if(sAmmo_rCheck(%db,%pl,0) <= 0)
	{
		%cnt = %pl.getDatablock().maxTools;
		for(%i=0;%i<%cnt;%i++)
		{
			%slot = %pl.tool[%i];
			if(%slot == nameToId(%db.item))
			{
				messageClient(%pl.client,'MsgItemPickup','',%i,0,1);
				%pl.tool[%i] = 0;
			}
		}
	}
	parent::onUnMount(%db,%pl,%slot);
}

function fragProjectile::onCollision(%this,%proj,%col,%fade,%pos,%normal)
{
	%proj.bounces += 1;
	if(%proj.bounces >= 3) 
	{
		%p = new projectile()
		{
			datablock = fragStaticProjectile;
			initialPosition = %proj.getPosition();
			initialVelocity = %proj.getVelocity();
			client = %proj.client;
			sourceObject = %proj.client;
			pleaseBlowMe = 1;
		};
		schedule(%proj.explodeIn-getSimTime(),%p,fragGrenade_explode,%p);
		%proj.delete();
	}
	else
		serverPlay3D(fragBounceSound,%proj.getTransform());
}
