datablock ItemData(ammo40mmGrenadesItem : ammoBox9mmItemA)
{
	shapeFile = "./model/gl_ammo.dts";
	iconName = "./model/icon/icon_ammoGL";
	uiName = "Ammo 40mm Grenades";
	sAmmo = 3;
	sAmmoType = "40mmGrenades";
	colorShiftColor = "1 1 1 1";
	doColorShift = false;
};
datablock AudioProfile(grenadeLauncherFireSound)
{
	filename    = "./sound/gl_fire.wav";
	description = AudioDefault3d;
	preload = true;
};
datablock AudioProfile(grenadeLauncherExplosionASound : grenadeLauncherFireSound)
{
	filename    = "./sound/gl_explodeA.wav";
	description = AudioDefault3D;
};
datablock AudioProfile(grenadeLauncherExplosionB1Sound : grenadeLauncherFireSound)
{
	filename    = "./sound/gl_explodeB1.wav";
	description = AudioDefault3D;
};
datablock AudioProfile(grenadeLauncherExplosionB2Sound : grenadeLauncherFireSound)
{
	filename    = "./sound/gl_explodeB2.wav";
	description = AudioDefault3D;
};
datablock AudioProfile(grenadeLauncherExplosionC1Sound : grenadeLauncherFireSound)
{
	filename    = "./sound/gl_explodeC1.wav";
	description = AudioDefault3D;
};
datablock AudioProfile(grenadeLauncherExplosionC2Sound : grenadeLauncherFireSound)
{
	filename    = "./sound/gl_explodeC2.wav";
	description = AudioDefault3D;
};
datablock AudioProfile(grenadeLauncherExplosionC3Sound : grenadeLauncherFireSound)
{
	filename    = "./sound/gl_explodeC3.wav";
	description = AudioDefault3D;
};
datablock AudioProfile(grenadeLauncherBreakSound : grenadeLauncherFireSound)
{
	filename    = "./sound/gl_break.wav";
	description = AudioClose3D;
};
datablock AudioProfile(grenadeLauncherUnBreakSound : grenadeLauncherFireSound)
{
	filename    = "./sound/gl_unbreak.wav";
	description = AudioClose3D;
};
datablock AudioProfile(grenadeLauncherLoadSound : grenadeLauncherFireSound)
{
	filename    = "./sound/gl_load.wav";
	description = AudioDefault3D;
};
datablock AudioProfile(grenadeLauncherLoopSound)
{
   filename    = "./sound/gl_loop.wav";
   description = AudioCloseLooping3d;
   preload = true;
};
datablock DebrisData(shellGrenadeDebris)
{
	shapeFile = "./model/gl_shell.dts";
	lifetime = 6.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 4;
};
datablock ParticleData(grenadeLauncherTrailParticle)
{
	dragCoefficient      = 1;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0;
	constantAcceleration = 0.0;
	lifetimeMS           = 1100;
	lifetimeVarianceMS   = 400;
	textureName          = "base/data/particles/cloud";
	spinSpeed			= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]			= "1 1 1 0.15";
	colors[1]			= "0.95 0.95 0.95 0.12";
	colors[2]			= "0.85 0.85 0.85 0";
	sizes[0]			= 0.45;
	sizes[1]			= 0.6;
	sizes[2]			= 0.55;
	times[0]			= 0;
	times[1]			= 0.2;
	times[2]			= 1;
	useInvAlpha 		= true;
};

datablock ParticleEmitterData(grenadeLauncherTrailEmitter)
{
	ejectionPeriodMS	= 4;
	periodVarianceMS	= 0;
	ejectionVelocity	= 0.5;
	velocityVariance	= 0.2;
	ejectionOffset  	= 0.0;
	thetaMin			= 0;
	thetaMax			= 90;
	phiReferenceVel		= 0;
	phiVariance			= 360;
	overrideAdvance		= false;
	particles			= grenadeLauncherTrailParticle;
};

datablock ParticleData(grenadeLauncherRingParticle)
{
	dragCoefficient      = 12;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0;
	constantAcceleration = 0.0;
	lifetimeMS           = 1500;
	lifetimeVarianceMS   = 400;
	textureName          = "base/data/particles/dot";
	spinSpeed			= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]			= "1 0.6 0 0.4";
	colors[1]			= "0.95 0.5 0 0.3";
	colors[2]			= "0.85 0.4 0 0";
	sizes[0]			= 1.15;
	sizes[1]			= 0.7;
	sizes[2]			= 0.2;
	times[0]			= 0;
	times[1]			= 0.2;
	times[2]			= 1;
	useInvAlpha 		= true;
};

datablock ParticleEmitterData(grenadeLauncherRingEmitter)
{
	ejectionPeriodMS	= 3;
	periodVarianceMS	= 0;
	ejectionVelocity	= 55;
	velocityVariance	= 20;
	ejectionOffset  	= 0.0;
	thetaMin			= 0;
	thetaMax			= 90;
	phiReferenceVel		= 0;
	phiVariance			= 360;
	overrideAdvance		= false;
	particles			= grenadeLauncherRingParticle;
};

datablock ParticleData(grenadeLauncherExplosionSmokeParticle)
{
	dragCoefficient      = 5;
	gravityCoefficient   = -0.1;
	inheritedVelFactor   = 0;
	constantAcceleration = 0.0;
	lifetimeMS           = 4700;
	lifetimeVarianceMS   = 900;
	textureName          = "base/data/particles/cloud";
	spinSpeed			= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]			= "0.4 0.4 0.4 0.2";
	colors[1]			= "0.5 0.5 0.5 0.1";
	colors[2]			= "0.6 0.6 0.6 0";
	sizes[0]			= 2;
	sizes[1]			= 5;
	sizes[2]			= 8;
	times[0]			= 0;
	times[1]			= 0.1;
	times[2]			= 1;
	useInvAlpha 		= true;
};

datablock ParticleEmitterData(grenadeLauncherExplosionSmokeEmitter)
{
	ejectionPeriodMS	= 3;
	periodVarianceMS	= 0;
	ejectionVelocity	= 4;
	velocityVariance	= 0;
	ejectionOffset  	= 4.0;
	thetaMin			= 0;
	thetaMax			= 90;
	phiReferenceVel		= 0;
	phiVariance			= 360;
	overrideAdvance		= false;
	particles			= grenadeLauncherExplosionSmokeParticle;
};

datablock ParticleData(grenadeLauncherExplosionFlareParticle)
{
	dragCoefficient      = 1;
	gravityCoefficient   = -0.6;
	inheritedVelFactor   = 0;
	constantAcceleration = 0.0;
	lifetimeMS           = 1700;
	lifetimeVarianceMS   = 200;
	textureName          = "base/data/particles/cloud";
	spinSpeed			= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]			= "1 0.7 0 0.6";
	colors[1]			= "0.9 0.3 0 0.5";
	colors[2]			= "0.7 0.2 0 0";
	sizes[0]			= 2;
	sizes[1]			= 9;
	sizes[2]			= 5;
	times[0]			= 0;
	times[1]			= 0.1;
	times[2]			= 1;
	useInvAlpha 		= false;
};

datablock ParticleEmitterData(grenadeLauncherExplosionFlareEmitter)
{
	ejectionPeriodMS	= 12;
	periodVarianceMS	= 0;
	ejectionVelocity	= 0;
	velocityVariance	= 0;
	ejectionOffset  	= 4.0;
	thetaMin			= 0;
	thetaMax			= 90;
	phiReferenceVel		= 0;
	phiVariance			= 360;
	overrideAdvance		= false;
	particles			= grenadeLauncherExplosionFlareParticle;
};

datablock DebrisData(grenadeLauncherExplosionDebris)
{
	shapeFile = "base/data/shapes/empty.dts";
	lifetime = 0.29;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;
	emitters[0] = grenadeLauncherTrailEmitter;
	emitters[1] = "";

	gravModifier = 0;
};

datablock explosionData(grenadeLauncherExplosion)
{
	lifetimeMS 				= 150;
	
	particleEmitter 		= grenadeLauncherExplosionFlareEmitter;
	particleDensity 		= 30;
	particleRadius 			= 0.2;
	soundProfile 			= grenadeLauncherExplosionASound;

	
	emitter[0]				= grenadeLauncherRingEmitter;
	emitter[1] 				= grenadeLauncherExplosionSmokeEmitter;
	
	debris 					= grenadeLauncherExplosionDebris;
	debrisNum 				= 13;
	debrisNumVariance 		= 2;
	debrisPhiMin 			= 0;
	debrisPhiMax 			= 360;
	debrisThetaMin 			= 0;
	debrisThetaMax 			= 180;
	debrisVelocity 			= 35;
	debrisVelocityVariance 	= 15;

	radiusDamage = 110;
	damageRadius = 14;
	
	impulseForce = 1800;
	impulseRadius = 20;
	
	faceViewer = 1;
	
	explosionScale = "1 1 1";
	
	shakeCamera = true;
	camShakeRadius = 20;
	camShakeAmp = "1 2 1";
	camShakeDuration = 3;
	camShakeFallOff = 10;
	camShakeFreq = "2 4 2";
	cameraShakeFalloff = 1;
};
datablock explosionData(grenadeLauncherRumbleExplosion)
{
	shakeCamera = true;
	camShakeRadius = 1;
	camShakeAmp = "1 2 1";
	camShakeDuration = 2;
	camShakeFallOff = 5;
	camShakeFreq = "3 5 3";
	cameraShakeFalloff = 1;
};
datablock ProjectileData(grenadeLauncherRumbleProjectile)
{
	explosion = grenadeLauncherRumbleExplosion;
};
datablock ProjectileData(grenadeLauncherProjectile : gunProjectile)
{
	projectileShapeName 	= "./model/gl_round.dts";
	directDamage        	= 50;
	explodeOnDeath = 1;
	explosion 				= grenadeLauncherExplosion;
	directDamageType    	= $DamageType::GrenadeLauncher;
	radiusDamageType    	= $DamageType::GrenadeLauncher;
	particleEmitter     	= grenadeLauncherTrailEmitter;
	uiName 					= "";
	muzzleVelocity 			= 200;
	verticalImpulse 		= 20;
	impactImpulse			= 20;
	lifeTime				= 20000;
	sound 					= grenadeLauncherLoopSound;
	sProjectile 			= 0;
	gravityMod 				= 1;
	isBallistic 			= 1;
	noBulletWhiz = 1;
	
	impactImpulse = 1000;
	verticalImpulse = 500;
};

datablock ItemData(grenadeLauncherItem)
{
	category = "Weapon";
	className = "Weapon";
	
	weaponClass = "primary";

	shapeFile = "./model/gl.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	uiName = "Grenade Launcher";
	iconName = "./model/icon/icon_gl";
	fakeIcon = grenadeLauncherIcon;
	doColorShift = true;
	colorShiftColor = "0.35 0.35 0.35 1";
	ammo = 1;
	canPutInSuitcase = 0;
	isLargeWeapon = 1;

	image = grenadeLauncherImage;
	canDrop = true;
	
	spawnMaxAmmoAlways = 1;
	noSpawnWithAmmoNear = 1;
	
	sAmmoType = "40mmGrenades";
	sAmmo = 1;
};

datablock ShapeBaseImageData(grenadeLauncherImage)
{
	className = "WeaponImage";
	shapeFile = "./model/gl.dts";
	emap = true;
	mountPoint = 0;
	offset = "0 0.02 0.04";
	item = grenadeLauncherItem;
	ammo = " ";
	projectile = grenadeLauncherProjectile;
	projectileType = Projectile;
	
	casing = shellGrenadeDebris;
	shellExitDir        = "0.4 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 12.0;	
	shellVelocity       = 7.0;
	
	armReady = true;
	
	eyeOffset = 0;
	
	doColorShift = true;
	colorShiftColor = grenadeLauncherItem.colorShiftColor;
	
	stateName[0]					= "Ready";
	stateSequence[0]				= "root";
	stateTimeoutValue[0]			= 0.3;
	stateTransitionOnTimeout[0] 	= "Idle";
	
	stateName[1]					= "Idle";
	stateTransitionOnTriggerDown[1]	= "FireCheckA";
	stateTransitionOnNotLoaded[1]	= "Break";
	
	stateName[3]					= "FireCheckA";
	stateScript[3]					= "onFireCheck";
	stateTimeoutValue[3]			= 0.01;
	stateTransitionOnTimeout[3]		= "FireCheckB";
	
	stateName[4]					= "FireCheckB";
	stateTransitionOnAmmo[4]		= "Fire";
	stateTransitionOnNoAmmo[4]		= "DryFire";
	
	stateName[5]					= "Fire";
	stateScript[5]					= "onFire";
	stateEmitter[5]					= gunFlashEmitter;
	stateEmitterTime[5]				= 0.05;
	stateFire[5]					= true;
	stateSequence[5]				= "trig";
	stateEmitterNode[5]				= "muzzlePoint";
	stateTransitionOnTimeout[5]     = "Release";
	stateTimeoutValue[5]            = 0.12;
	
	stateName[6]					= "Release";
	stateScript[6]					= "onRelease";
	stateTransitionOnTriggerUp[6]	= "Wait";
	
	stateName[7]					= "Wait";
	stateTimeoutValue[7]			= 0.3;
	stateTransitionOnTimeout[7]		= "Idle";
	
	stateName[8]					= "DryFire";
	stateSequence[8]				= "trig";
	stateScript[8]					= "onDryFire";
	stateTransitionOnTimeout[8]    = "Release";
	stateTimeoutValue[8]           = 0.12;
	
	stateName[9]					= "Break";
	stateTimeoutValue[9]			= 0.15;
	stateSequence[9]				= "open";
	stateScript[9]					= "onBreak";
	stateTransitionOnTimeout[9]		= "UnloadA";
	
	stateName[10]					= "UnloadA";
	stateScript[10]					= "onUnload";
	stateSequence[10]				= "eject";
	stateTimeoutValue[10]			= 0.01;
	stateEjectShell[10]				= true;
	stateTransitionOnTimeout[10]	= "UnloadB";
	
	stateName[11]					= "UnloadB";
	stateTimeoutValue[11]			= 0.2;
	stateTransitionOnTimeout[11]	= "LoadA";
	
	stateName[12]					= "LoadA";
	stateTimeoutValue[12]			= 0.4;
	stateTransitionOnTimeout[12]	= "LoadB";
	
	stateName[13]					= "LoadB";
	stateScript[13]					= "onLoad";
	stateSequence[13]				= "load";
	stateTimeoutValue[13]			= 0.01;
	stateTransitionOnTimeout[13]	= "LoadC";
	
	stateName[14]					= "LoadC";
	stateTimeoutValue[14]			= 0.45;
	stateTransitionOnTimeout[14]	= "UnBreak";
	
	stateName[15]					= "UnBreak";
	stateTimeoutValue[15]			= 0.15;
	stateSequence[15]				= "close";
	stateScript[15]					= "onUnBreak";
	stateTransitionOnTimeout[15]	= "Idle";
};
function grenadeLauncherImage::onFire(%db,%pl,%slot)
{
	if(%pl.getDamagePercent() >= 1)
		return;
	%pl.playThread(2,plant);
	%proj = sAmmo_fire(%db,%pl,%slot,0.005,40,1);
	serverPlay3D(grenadeLauncherFireSound,%pl.getPosition());
	%val = sAmmo_dec(%db,%pl,%slot);
	if(%val == 0)
		%pl.setImageAmmo(%slot,0);
}
function grenadeLauncherImage::onFireCheck(%db,%pl,%slot)
{
	%pl.setImageAmmo(%slot,sAmmo_check(%db,%pl,%slot));
}
function grenadeLauncherImage::onDryFire(%db,%pl,%slot)
{
	%pl.sAmmo_warn = "warn";
	%pl.sAmmo_warnMax = 150;
	%pl.sAmmo_lastWarn = getSimTime();
	sAmmo_display(%pl);
	serverPlay3D(flareGunDryFireSound,%pl.getPosition());
}
function grenadeLauncherImage::onLoad(%db,%pl,%slot)
{
	%pl.playThread(2,plant);
	serverPlay3D(grenadeLauncherLoadSound,%pl.getPosition());
	sAmmo_reload(%db,%pl,%slot);
	%pl.sAmmo_fireDelay = getSimTIme()+830;
}
function grenadeLauncherImage::onBreak(%db,%pl,%slot)
{
	%pl.playThread(2,plant);
	serverPlay3D(grenadeLauncherBreakSound,%pl.getPosition());
	
	schedule(getRandom(500,600),0,serverPlay3D,dbShotgunShellDrop @ getRandom(1,2) @ Sound,%pl.getPosition());
}
function grenadeLauncherImage::onUnBreak(%db,%pl,%slot)
{
	%pl.playThread(2,plant);
	%pl.setImageLoaded(%slot,1);
	serverPlay3D(grenadeLauncherUnBreakSound,%pl.getPosition());
}