datablock AudioProfile(molotovThrowSound)
{
	filename    = "./sound/molotov_throw.wav";
	description = AudioClose3d;
	preload = true;
};
datablock AudioProfile(molotovLightSound)
{
	filename    = "./sound/molotov_light.wav";
	description = AudioClose3d;
	preload = true;
};
datablock AudioProfile(molotovExplosionSound)
{
	filename    = "./sound/molotov_explode.wav";
	description = AudioDefault3d;
	preload = true;
};
datablock AudioProfile(molotovLoopSound)
{
	filename    = "./sound/molotov_loop.wav";
	description = AudioCloseLooping3D;
	preload = true;
};
datablock ParticleData(molotovExplosionSmokeParticle)
{
	dragCoefficient      = 5;
	gravityCoefficient   = -0.1;
	inheritedVelFactor   = 0;
	constantAcceleration = 0.0;
	lifetimeMS           = 4700;
	lifetimeVarianceMS   = 900;
	textureName          = "base/data/particles/cloud";
	spinSpeed			= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]			= "0.1 0.1 0.1 0.2";
	colors[1]			= "0.2 0.2 0.2 0.1";
	colors[2]			= "0.4 0.4 0.4 0";
	sizes[0]			= 2;
	sizes[1]			= 5;
	sizes[2]			= 7;
	times[0]			= 0;
	times[1]			= 0.1;
	times[2]			= 1;
	useInvAlpha 		= true;
};

datablock ParticleEmitterData(molotovExplosionSmokeEmitter)
{
	ejectionPeriodMS	= 3;
	periodVarianceMS	= 0;
	ejectionVelocity	= 4;
	velocityVariance	= 0;
	ejectionOffset  	= 0.1;
	thetaMin			= 0;
	thetaMax			= 90;
	phiReferenceVel		= 0;
	phiVariance			= 360;
	overrideAdvance		= false;
	particles			= molotovExplosionSmokeParticle;
};
datablock explosionData(molotovExplosion)
{
	lifetimeMS 				= 150;
	
	particleEmitter 		= molotovExplosionSmokeEmitter;
	particleDensity 		= 12;
	particleRadius 			= 0.5;
	soundProfile 			= "";

	
	emitter[0]				= "";
	
	debris 					= "";
	debrisNum 				= 0;
	debrisNumVariance 		= 0;

	radiusDamage = 0;
	damageRadius = 0;
	
	impulseForce = 0;
	impulseRadius = 0;
	
	faceViewer = 1;
	
	explosionScale = "1 1 1";
	
	shakeCamera = true;
	camShakeRadius = 20;
	camShakeAmp = "1 2 1";
	camShakeDuration = 3;
	camShakeFallOff = 10;
	camShakeFreq = "2 4 2";
	cameraShakeFalloff = 1;
};
datablock ParticleData(molotovSparkParticle)
{
	dragCoefficient      = 1;
	gravityCoefficient   = -1;
	inheritedVelFactor   = 0.4;
	constantAcceleration = 0.0;
	lifetimeMS           = 425;
	lifetimeVarianceMS   = 255;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 16.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.7 0.6 0.3 0.8";
	colors[1]     = "0.9 0.4 0.1 0.5";
	colors[2]     = "0.9 0.2 0.1 0.2";
	colors[3]     = "0.9 0.1 0.1 0";
	sizes[0]      = 0.18;
	sizes[1]      = 0.22;
	sizes[2]      = 0.29;
	sizes[3]      = 0.17;
   times[0] = 0.0;
   times[1] = 0.3;
   times[2] = 0.6;
   times[3] = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(molotovSparkEmitter)
{
   ejectionPeriodMS = 8;
   periodVarianceMS = 0;
   ejectionVelocity = 0.1;
   velocityVariance = 0;
   ejectionOffset   = 0.05;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   orientOnVelocity = true;
   particles = molotovSparkParticle;
};
datablock ProjectileData(molotovProjectile : gunProjectile)
{
	projectileShapeName 	= "./model/molotov_proj.dts";
	directDamage        	= 5;
	explodeOnDeath = 1;
	explosion 				= molotovExplosion;
	directDamageType    	= $DamageType::Flamer;
	radiusDamageType    	= $DamageType::Flamer;
	particleEmitter     	= molotovSparkEmitter;
	uiName 					= "";
	muzzleVelocity 			= 200;
	verticalImpulse 		= 20;
	impactImpulse			= 20;
	lifeTime				= 20000;
	sound 					= "";
	sProjectile 			= 0;
	noBulletWhiz = 1;
	gravityMod 				= 1;
	isBallistic 			= 1;
	
	sound = molotovLoopSound;
	
	impactImpulse = 0;
	verticalImpulse = 0;
};
datablock ItemData(molotovItem)
{
	category = "Weapon";
	className = "Weapon";
	
	weaponClass = "slot3";

	shapeFile = "./model/molotov.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	uiName = "Molotov";
	iconName = "./model/icon/icon_molotov";
	fakeIcon = c4Icon;
	doColorShift = true;
	colorShiftColor = "0.4 0.2 0 1";
	ammo = 1;
	canPutInSuitcase = 0;
	isLargeWeapon = 0;

	image = molotovImage;
	canDrop = true;
	
	sAmmoType = "molotov";
	sAmmoMode = "thrown";
	sAmmo = 1;
	sAmmoPickupGenericNoise = 1;
	noAmmolessSpawn = 1;
};
datablock ShapeBaseImageData(molotovImage)
{
	className = "WeaponImage";
	shapeFile = "./model/molotov.dts";
	emap = true;
	mountPoint = 0;
	offset = "-0.01 0.035 0";
	eyeOffset = "0 0 0";
	rotation = "0 0 1 20";
	eyeRotation = "0 0 0 0";
	item = molotovItem;
	ammo = " ";
	
	armReady = true;
	
	projectile = molotovProjectile;
	projectileType = Projectile;
	
	
	doColorShift = true;
	colorShiftColor = molotovItem.colorShiftColor;
	
	stateName[0]					= "Idle";
	stateTransitionOnNotLoaded[0]	= "FireA";
	
	stateName[1]					= "FireA";
	stateEmitter[1]					= molotovSparkEmitter;
	stateEmitterNode[1]				= "muzzlePoint";
	stateEmitterTime[1]				= 100;
	stateTransitionOnTimeout[1]		= "FireB";
	stateTimeoutValue[1]			= 100;
	
	stateName[2]					= "FireB";
	stateEmitter[2]					= molotovSparkEmitter;
	stateEmitterNode[2]				= "muzzlePoint";
	stateEmitterTime[2]				= 100;
	stateTransitionOnTimeout[2]		= "FireA";
	stateTimeoutValue[2]			= 100;
};
function molotovImage::onUnMount(%db,%pl,%slot)
{
	if(isObject(%obj = %pl.molotovWhickBot))
	{
		if(%obj.getDatablock() == nameToId(molotovSparkAnimPlayer))
		{
			%obj.delete();
		}
		if(isObject(%armorHead = %pl.getMountNodeObject($headSlot)))
		{
			if(isFunction(Player,setNetFlag))
			{
				%armorHead.setNetFlag(6,0);
				%armorHead.scopeToClient(%pl.client);
				cancel(%pl.armorScopeFirstPersonLoopSched);
			}
		}
	}
	%pl.molotovIgnited = 0;
	%pl.disableCmdSwap = 0;
	sWeps_loopingAudioEnd(%db,%pl,%slot);
	if(sAmmo_rCheck(%db,%pl,0) <= 0)
	{
		%cnt = %pl.getDatablock().maxTools;
		for(%i=0;%i<%cnt;%i++)
		{
			%slot = %pl.tool[%i];
			if(%slot == nameToId(%db.item))
			{
				messageClient(%pl.client,'MsgItemPickup','',%i,0,1);
				%pl.tool[%i] = 0;
			}
		}
	}
	parent::onUnMount(%db,%pl,%slot);
}
function player::igniteMolotov(%pl)
{
	%pl.playThread(2,shiftLeft);
	%pl.disableCmdSwap = 1;
	%pl.molotovIgnited = 1;
	if(isObject(molotovSparkAnimPlayer))
	{
		if(isObject(%pl.molotovWhickBot))
			%pl.molotovWhickBot.delete();
		%a = new aiPlayer()
		{
			datablock = molotovSparkAnimPlayer;
			position = %pl.getPosition();
			scale = "1 1 1";
		};
		%a.setDamageLevel(100);
		%a.mountImage(molotovSparkAnim,1);
		%pl.mountObject(%a,0);
		%pl.molotovWhickBot = %a;
		%a.playThread(1,root);
		%a.schedule(10,playThread,1,anim);
		if(isObject(%pl.getMountNodeObject($headSlot)))
		{
			%pl.armorScopeFirstPersonLoop();
		}
	}
	else
	{
		%pl.setImageLoaded(0,0);
	}
	sWeps_loopingAudioStart(nameToID(molotovImage),%pl,0,molotovLoopSound);

	%pl.molotovIgniteTime = getSimTime();
	cancel(%pl.molotovExplodeInHand);
	%pl.molotovExplodeInHand = %pl.schedule(11000,molotovExplodeInhand);
	serverPlay3D(molotovLightSound,%pl.getPosition()); 
}
function player::molotovExplodeInhand(%pl)
{
	cancel(%pl.molotovExplodeInHand);
	%pos = %pl.getSlotTransform(0);
	molotov_explode(%pos,%pl,%pl.client);
	%item = molotovItem;
	sAmmo_rDec(%item.image,%pl,0);
	%pl.unMountImage(0);
	%pl.playThread(1,root);
}
function molotovProjectile::onExplode(%db,%proj,%expos,%b)
{
	parent::onExplode(%db,%proj,%expos,%b);
	molotov_explode(%expos,%proj,%proj.client);
}
function molotov_explode(%pos,%obj,%cl)
{
	createFireCircle(%pos,10,30,%cl,%obj,$DamageType::Molotov);
	%mask = $TypeMasks::PlayerObjectType;
	%max = 6;
	initContainerRadiusSearch(%pos,%max,%mask);
	while(%pl = containerSearchNext())
	{
		if(isObject(%pl.client) && !isObject(%pl.client.minigame))
			continue;
		if(%pl.getDatablock().noBurning)
			continue;
		if(minigameCanDamage(%obj,%pl) != 1)
			continue;
		%dist = vectorDist(%pl.getPosition(),%pos);
		%dmg = (%p=(1-(%dist/%max)))*40;
		if(%p > 0.2)
		{
			%pl.lastBurnDmgType = $DamageType::Molotov;
			%pl.lastFireAttacker = %proj.client;
			%pl.flamer_burnStart(mCeil(%p*8));
		}
		%pl.damage(%obj.client,%pl.getPosition(),%dmg,$DamageType::Molotov);
	}
	serverPlay3D(molotovExplosionSound,%pos);
}