datablock AudioProfile(syringeStabSound)
{
	filename    = "./sound/syringe_stab.wav";
	description = AudioClose3d;
	preload = true;
};
datablock AudioProfile(pickupSyringeSound : syringeStabSound)
{
	filename    = "./sound/syringe_pickup.wav";
	description = AudioClose3d;
};
datablock ParticleData(syringeHealParticle)
{
	dragCoefficient      = 5;
	gravityCoefficient   = 0.0;
	inheritedVelFactor   = 1.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 500;
	lifetimeVarianceMS   = 300;
	textureName          = "Add-Ons/Projectile_Pong/square";
	spinSpeed		= 0.0;
	spinRandomMin		= -0.0;
	spinRandomMax		= 0.0;
	colors[0]     = "0.6 0 0 0.1";
	colors[1]     = "0.6 0 0 0";
	sizes[0]      = 1.4;
	sizes[1]      = 0.0;
};

datablock ParticleEmitterData(syringeHealEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = syringeHealParticle;
};
datablock explosionData(syringeHealExplosion)
{
	particleEmitter = syringeHealEmitter;
	particleDensity = 30;
	particleRadius = 0.5;
	
	lifetimeMs = 100;
};
datablock ProjectileData(syringeHealProjectile)
{
	explosion = syringeHealExplosion;
};
datablock DebrisData(syringeDebris)
{
	emitters = "";

	shapeFile = "./model/syringe_debris.dts";
	lifetime = 3.0;
	minSpinSpeed = -700.0;
	maxSpinSpeed = -150.0;
	elasticity = 0.3;
	friction = 0.1;
	numBounces = 4;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};
datablock ShapeBaseImageData(syringeTossFPImage)
{
	shapeFile = "./model/syringe.dts";
	item = syringeItem;
	offset = "0 0 1000";
	mountPoint = 0;
	eyeOffset = "0.6 1.1 -0.6";
	
	stateName[0]					= "Start";
	stateTimeoutValue[0]			= 0.3;
	stateSequence[0]				= "toss";
	stateTransitionOnTimeout[0] 	= "Done";
	
	stateName[1]					= "Done";
	stateScript[1]					= "onDone";
};
function syringeTossFPImage::onDone(%db,%pl,%slot)
{
	%pl.unMountIMage(%slot);
}
datablock ShapeBaseImageData(syringeTossImage)
{
	shapeFile = "base/data/shapes/empty.dts";
	casing = syringeDebris;
	item = syringeItem;
	offset = "0 0 0.1";
	mountPoint = 0;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 0;
	shellVelocity       = 7.0;
	eyeOffset = "0 -0.4 -0.2";
	
	stateName[0]					= "Start";
	stateTimeoutValue[0]			= 0.3;
	stateSequence[0]				= "toss";
	stateEjectShell[0]				= true;
	stateTransitionOnTimeout[0] 	= "Done";
	
	stateName[1]					= "Done";
};
function syringeTossImage::onMount(%db,%pl,%slot)
{
	%pl.mountImage(syringeTossFPImage,1);
}
datablock ItemData(syringeItem)
{
	category = "Weapon";
	className = "Weapon";
	
	weaponClass = "slot3";

	shapeFile = "./model/syringe_item.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	iconName = "./model/icon/icon_syringe";
	fakeIcon = c4Icon;
	doColorShift = true;
	colorShiftColor = "1 0 0.2 1";
	ammo = 1;
	canPutInSuitcase = 1;
	isLargeWeapon = 0;

	image = syringeImage;
	canDrop = true;
	
	sAmmoType = "syringe";
	sAmmoMode = "thrown";
	sAmmo = 1;
	sAmmoPickupGenericNoise = 1;
	sAmmoPickupNoise = "syringe";
	noAmmolessSpawn = 1;
	
	uiName = "Syringe ";
};

datablock ShapeBaseImageData(syringeImage)
{
	className = "WeaponImage";
	shapeFile = "./model/syringe.dts";
	emap = true;
	mountPoint = 0;
	offset = "-0.01 0.01 -0.1";
	eyeOffset = "0 0 0";
	rotation = "0 0 0 0";
	eyeRotation = "0 0 0 0";
	eyeOffset = "0.6 1.1 -0.6";
	item = syringeItem;
	ammo = " ";
	
	armReady = true;
	
	
	doColorShift = true;
	colorShiftColor = syringeItem.colorShiftColor;
	
	stateName[0] 					= "Ready";
	stateTransitionOnTimeout[0] 	= "Idle";
	stateTimeoutValue[0]			= 0.3;
	
	stateName[1]					= "Idle";
	stateTransitionOnTriggerDown[1]	= "Heal";
	
	stateName[2]					= "Heal";
	stateScript[2]					= "onHeal";
	stateSequence[2]				= "anim";
	stateTimeoutValue[2]			= 0.65;
	stateTransitionOnTimeout[2]		= "Done";
	
	stateName[3]					= "Done";
	stateScript[3]					= "onDone";
};
function syringeImage::onDone(%db,%pl,%slot)
{
	%pl.schedule(500,mountImage,syringeTossImage,0);
	%pl.schedule(1100,playThread,1,root);
	%pl.schedule(502,playThread,2,activate);
	%pl.schedule(1050,playThread,2,shiftTo);
	%pl.schedule(1120,delayedCmdSwap);
	%pl.schedule(1150,doImageRemount,syringeImage);
	%pl.schedule(685,unMountImage,0);
}
function syringeImage::onHeal(%db,%pl,%slot)
{
	%pl.disableCmdSwap = 1;
	%db.schedule(220,onPlunge,%pl,%slot);
}
function syringeImage::onPlunge(%db,%pl,%slot)
{
	sAmmo_rDec(%db,%pl,%slot);
	%pl.setWhiteOut(0.2);
	%pl.playThread(2,plant);
	%pl.playThread(3,shiftTo);
	%pl.playAudio(2,syringeStabSound);
	%p = new projectile()
	{
		datablock = syringeHealProjectile;
		initialVelocity = %pl.getEyeVector();
		initialPosition = vectorAdd(%pl.getPosition(),"0 0 1");
	};
	%p.explode();
	if(sAmmo_rCheck(%db,%pl,0) <= 0)
	{
		%cnt = %pl.getDatablock().maxTools;
		for(%i=0;%i<%cnt;%i++)
		{
			%slot = %pl.tool[%i];
			if(%slot == nameToId(%db.item))
			{
				messageClient(%pl.client,'MsgItemPickup','',%i,0,1);
				%pl.tool[%i] = 0;
			}
		}
	}
	%pl.healUpTick += 75;
	$test = getSimTime();
	%pl.syringeHealLoop();
}
function player::syringeHealLoop(%pl)
{
	cancel(%pl.syringeHealSched);
	if(%pl.healUpTick <= 0)
		return;
	%prcnt = (%pl.healUpTick/75);
	%amt = mClampF(%pl.healUpTick*%prcnt*0.1,0.5,5);
	if(%pl.healUpTick < %amt)
		%amt = %pl.healUpTick;
	%pl.healUpTick -= %amt;
	if(%pl.getDamageLevel() != 0)
	{
		%pl.addHealth(%amt);
	}
	%pl.syringeHealSched = %pl.schedule(100,syringeHealLoop);
}